///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2015 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using com.espertech.esper.regressionlib.framework;
using com.espertech.esper.regressionlib.support.bean;

using NUnit.Framework;

namespace com.espertech.esper.regressionlib.suite.@event.bean
{
    public class EventBeanPropertyResolutionAccessorStyleGlobalPublic : RegressionExecution
    {
        public void Run(RegressionEnvironment env)
        {
            env.CompileDeploy("@Name('s0') select fieldLegacyVal from SupportLegacyBean").AddListener("s0");

            var theEvent = new SupportLegacyBean("E1");
            theEvent.fieldLegacyVal = "val1";
            env.SendEventBean(theEvent);
            Assert.AreEqual("val1", env.Listener("s0").AssertOneGetNewAndReset().Get("fieldLegacyVal"));

            env.UndeployAll();
        }
    }
} // end of namespace